<?php
namespace Geral\Util;
/**
 * User: newtonsantos
 * Date: 12/07/2013
 * Time: 11:47
 * To change this template use File | Settings | File Templates.
 */
use \Geral\Logic\Picture;
class PictureItemTrabalho extends Picture
{

    const PICTURE = 'CDPICTITTRAB';


    public function __construct() {
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        parent::__construct($nrorg, $this::PICTURE);
    }

    public static function isItemTrabalhoNivelMaximo($cditemtrab, $nrorg = null, $nivel = null) {
        if(empty($nrorg)) {
            $nrorg = \Geral\Util\Ambiente::getNrorg();
        }
        if(empty($nivel)) {
            $itemtrab = \Geral\Entities\Itemtrab::getRepository()->findOneBy(array("cditemtrab" => $cditemtrab, "nrorg" => $nrorg));
            if(!$itemtrab instanceof \Geral\Entities\Itemtrab) {
                throw new \Exception("Item de trabalho não encontrado.");
            }
            $nivel = $itemtrab->getCdnvitemtrab();
        }
        return ($nivel == self::retornaNumeroMaximoDeNiveis());
    }

    public static function retornaNumeroMaximoDeNiveis() {
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $picture = new self($nrorg);
        return $picture->getNumeroDeNiveis();
    }

    /**
     * Mascara do Item de trabalho.
     *
     * @return mixed
     */
    public static function mascaraItemTrabalho(){
        $pic = new self();
        return $pic->getMascara();
    }


}
